#ifndef __JOBS_CLIENT_H__
#define __JOBS_CLIENT_H__

#include <string>
#include <map>

#include "../client/client.h"
#include <arc/url.h>

#include "jobs_soap.nsmap"

#ifndef TIMEOUT
#define TIMEOUT 120
#endif

class JobHTTPControl {
	public:
		JobHTTPControl(); // throw(JobHTTPControlError);
		~JobHTTPControl();
		operator bool(void);
		bool operator!(void);
		std::string Submit(const URL& url,
                           const std::string& rsl,
		                   bool disconnectafteruse = true,
		                   int timeout = TIMEOUT);
		//throw(JobHTTPControlError);
		std::string Submit(const URL& url,
		                   const std::string& rsl,
		                   std::map<std::string,std::string>& files,
		                   bool disconnectafteruse = true,
		                   int timeout = TIMEOUT);
		//throw(JobFTPControlError, FTPControlError);
		bool Cancel(const std::string& jobid,
		            bool disconnectafteruse = true,
		            int timeout = TIMEOUT);
		//throw(JobFTPControlError, FTPControlError);
		bool Clean(const std::string& jobid,
		           bool disconnectafteruse = true,
		           int timeout = TIMEOUT);
		//throw(JobFTPControlError, FTPControlError);
		bool RenewCreds(const std::string& jobid,
		                bool disconnectafteruse = true,
		                int timeout = TIMEOUT);
		//throw(JobFTPControlError, FTPControlError);
	private:
		std::string jobid_;
		std::string joburl_;
		URL url_;
		HTTP_ClientSOAP* client_;
		struct soap soap_;
};

#endif // __JOBS_CLIENT_H__
